<?php
/*
Plugin Name: [GWA] AutoResponder
Plugin URI: http://Cookies4Code.com
Description:A plugin to add an Auto-Responder and Opt-in Mail List Builder to your blog.
Version: 2.1.2
Author: pomspot
Author URI: http://Cookies4Code.com
*/

/*
    2.0.1 Notes
    - release

    2.0.2 Notes
    - reordered functions and classes
    - fixed scheduler for wp-cron ver. < 2.5
    - fixed wp-blog-header call and alternate for set
      direct dynamic dir & include in widget/forms

    2.1 Notes
    - added tinymce editor option on email compose page
    - added leads list re-ordering/sorting
    - update include path for wp-blog-header.php
    - email header corrections on [email leads]
    - changed displayed/internal website info & links

    2.1.1 Notes
    - added tinymce to one-time list mailer
    - add duplicate check on import list
    - send 'Day 0' email to list on import
    - remove/modify PHP5_ONLY functions
    
    2.1.2 Notes
    - relative url conversiona in TinyMCE fixed
    - host domain stripping on urls eliminated
*/

/*
    Copyright 2008  G.J.P  (email : cookies@getwebactive.com)
    Released under the GPL license
    All rights reserved.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

$dir = preg_split("/\//",dirname(__FILE__));
for($i=1;$i<(count($dir)-3);$i++)  {
$hdr_path .= '/'.$dir[$i];
}

if(file_exists(ABSPATH.'wp-content/plugins/autoresponder-gwa/ar_gwa.php'))
  $ar_dir = 'autoresponder-gwa';
else 
  $ar_dir = 'ar_gwa';
  $blog_header = $hdr_path.'/wp-blog-header.php';

if ($_REQUEST['act']=='s_add') {
require_once($blog_header);
$lEmail = $wpdb->escape($_REQUEST['email']);
$lName = $wpdb->escape($_REQUEST['name']);
 if(check_email($lEmail)){
  global $wpdb;
  $wpdb->show_errors;
	$qry = "SELECT * FROM ".$wpdb->prefix."ar_gwa_leads WHERE lEmail='".$lEmail."'";
	if($wpdb->get_results($qry)) { $g_error[] = 10; }

	if(!count($g_error))
	{	
		$qry = "INSERT INTO ".$wpdb->prefix."ar_gwa_leads(lName, lEmail, lDateEntry, lDateOut, lMOut) VALUES('".$lName."', '".$lEmail."' ,current_date, current_date, '-1')";
		$wpdb->query($qry);
		$ms = new MailProcess();
		if( $ms->setLead($wpdb->insert_id) && $ms->setMsg(0))
		{
		$ms->mailLead(0,$wpdb->insert_id);
//
get_header();
get_sidebar();
echo '<div id="main"><div class="main-text">'.stripslashes(stripslashes(get_option('ar_gwa_addlead'))).'</div></div>';
get_footer();
exit;
//
    exit;
    }
	} else {
//
get_header();
get_sidebar();
echo '<div id="main"><div class="main-text">'.stripslashes(stripslashes(get_option('ar_gwa_badlead'))).'</div></div>';
get_footer();
exit;
//
}
 } else if(isset($_REQUEST['s_add'])) {
//
get_header();
get_sidebar();
echo '<div id="main"><div class="main-text">'.stripslashes(stripslashes(get_option('ar_gwa_badlead'))).'</div></div>';
get_footer();
exit;
//
 }
} else if (isset($_REQUEST['uID']) && preg_match("/^\d+$/",$_REQUEST['uID'])) {
require_once($blog_header);
  $lEmail = $wpdb->escape($_REQUEST['lEmail']);
  $uID = $_REQUEST['uID'];
  global $wpdb;
  $wpdb->show_errors;
  $qry = "DELETE FROM ".$wpdb->prefix."ar_gwa_leads WHERE lID='".$uID."' AND lEmail='".$lEmail."'";
  if($wpdb->query($qry))
    $m = stripslashes(stripslashes(get_option('ar_gwa_rmvlead')));
  else
    $m = "<p>Failed to Unsubscribe $lEmail. Contact the webmaster ".get_bloginfo('admin_email');
//
get_header();
get_sidebar();
echo '<div id="main"><div class="main-text">'.$m.'</div></div>';
get_footer();
//
}

 if (!wp_next_scheduled('my_daily_event') || ((wp_next_scheduled('my_daily_event')-time())<0) ) {
  wp_clear_scheduled_hook('my_daily_event');
 $sched = time()+86000;
 wp_schedule_event( $sched, 'daily', 'my_daily_event' );
 do_this_daily('none');
 }

function check_email($email)
{
    $atom = '[-a-z0-9!#$%&\'*+/=?^_`{|}~]';
    $domain = '[a-z0-9]([-a-z0-9]{0,61}[a-z0-9])';
    return eregi("^$atom+(\\.$atom+)*@($domain?\\.)+$domain\$", $email);
}

if (function_exists('wp_enqueue_script')) wp_enqueue_script('admin-forms');
add_action('autoresponder_gwa_form_display', 'autoresponder_gwa_form_display');
add_action('wp_dashboard_setup', 'ar_gwa_register_dashboard_widget');
function ar_gwa_register_dashboard_widget() {
  global $ar_dir;
	wp_register_sidebar_widget('dashboard_ar_gwa', __('<a href="http://Cookies.GetWebActive.com">Cookies.GetWebActive.com</a>', 'ar_gwa'), 'dashboard_ar_gwa',
		array('all_link' => 'admin.php?page='.$ar_dir.'/ar_gwa.php','feed_link' => 'http://code4cookies.com/feed','width' => 'half','height' => 'single'));
}
add_filter('wp_dashboard_widgets', 'ar_gwa_add_dashboard_widget');
function ar_gwa_add_dashboard_widget($widgets) {
	global $wp_registered_widgets;
	if (!isset($wp_registered_widgets['dashboard_ar_gwa'])) {
		return $widgets;
	}
	array_splice($widgets, sizeof($widgets)-1, 0, 'dashboard_ar_gwa');
	return $widgets;
}

function dashboard_ar_gwa($sidebar_args) {
	global $wpdb;
	extract($sidebar_args, EXTR_SKIP);
	echo $before_widget;
	echo $before_title;
	echo $widget_name;
	echo $after_title;
	echo '<p><u>[GWA] AutoResponder Statistics</u><br />';
	admin_ar_gwa_get_stats(1);
	echo $after_widget;
}

function admin_ar_gwa_get_stats($d) {
global $wpdb,$ar_dir;
$wpdb->show_errors;
$qry = "SELECT COUNT(*) FROM ".$wpdb->prefix."ar_gwa_leads";
$num = $wpdb->get_var($qry);
$qry = "SELECT COUNT(*) FROM ".$wpdb->prefix."ar_gwa_leads WHERE "
          ."lDateEntry = current_date";
$today =  $wpdb->get_var($qry);
$timestamp = time() - (7 * 86400);
$qry = "SELECT COUNT(*) FROM ".$wpdb->prefix."ar_gwa_leads WHERE "
          ."lDateEntry > FROM_UNIXTIME($timestamp)";
$week =  $wpdb->get_var($qry);
$timestamp = time() - (30 * 86400);
$qry = "SELECT COUNT(*) FROM ".$wpdb->prefix."ar_gwa_leads WHERE "
          ."lDateEntry > FROM_UNIXTIME($timestamp)";
$month =  $wpdb->get_var($qry);
echo "<div style='position:relative;float:left;'><div style='position:relative;float:left;width:45%'>";
echo "Total addresses subscribed: $num<br /><br />Email added today: $today<br />Email added this week: $week<br />Email added this month: $month<br /><br />";
echo "Next Mailing in ".round(((((wp_next_scheduled('my_daily_event')-time())/60)/60)),1) . ' hours.'; 
echo '<br /><strong><small>'.date('l jS \of F Y h:i:s A',wp_next_scheduled('my_daily_event')).'</small></strong></div>';
echo "<div style='position:relative;float:left;width:45%'>";
echo 'More plugins available. Join the Newsletter to stay informed.<br />';
echo "<form action='http://code4cookies.com/wp-content/plugins/".$ar_dir."/ar_gwa.php' method='POST'><input name='email' type='text' value='".get_bloginfo('admin_email')."' size=22><br /><input name='name' type='text' value='".get_bloginfo('admin_name')."' size=22><br /><input type='submit' value='SUBSCRIBE' name='SUBMIT' class='button'><input type='hidden' name='act' value='s_add'></form><br /><br /></div>";

	$popular = @fetch_rss( 'http://code4cookies.com/feed' );

	foreach ( array( 'popular' => __('<br /><a href="http://code4cookies.com">Most Recent Post</a>') ) as $feed => $label ) {
		if ( !isset($$feed->items) || 0 == count($$feed->items) )
			continue;

		$$feed->items = array_slice($$feed->items, 0, 1);
		$item_key = array_rand($$feed->items);

		// Eliminate some common badly formed plugin descriptions
		while ( ( null !== $item_key = array_rand($$feed->items) ) && false !== strpos( $$feed->items[$item_key]['description'], 'Plugin Name:' ) )
			unset($$feed->items[$item_key]);

		if ( !isset($$feed->items[$item_key]) )
			continue;
		$item = $$feed->items[$item_key];
		// current bbPress feed item titles are: user on "topic title"
		if ( preg_match( '/"(.*)"/s', $item['title'], $matches ) )
			$title = $matches[1];
		else // but let's make it forward compatible if things change
			$title = $item['title'];
		$title = wp_specialchars( $title );
		$description = wp_specialchars( strip_tags(html_entity_decode($item['description'], ENT_QUOTES)) );
		echo "<div style='width:90%;margin-top:35px;'><p><h4>Most Recent Post @ <a href='http://Code4Cookies.com'>Code4Cookies.com</a></h4>\n";
		echo "$description</p></div></div>\n";
	}	
	echo '</div>';
}

function ar_gwa_optin_init()  
        {  

	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
		return;
            // Register myplugin_widget::display() and myplugin_widget::control()  
      
        function ar_gwa_display()  
        {  
           // Echo content 
$defaultKeyword = get_option('defaultKeyword');
?>
          <?php do_action('autoresponder_gwa_form_display'); ?>
	<?php
       }  
     
       function ar_gwa_control()  
       {  
           // Echo administration control  
       }  
 register_sidebar_widget(array('[GWA] Autoresponder', 'widgets',''), 'ar_gwa_display');     
   }
add_action('widgets_init', 'ar_gwa_optin_init');

function admin_ar_gwa_main() {
global $ar_dir;
if($_REQUEST['act']=='main') {
 if(isset($_REQUEST['sched'])) {
  wp_clear_scheduled_hook('my_daily_event');
	wp_schedule_event((time()+86400), 'daily', 'my_daily_event');
 } else if(isset($_REQUEST['submit']) || isset($_REQUEST['update'])) {
  set_ar_gwa_options();
 }
}

echo '<div id="wpbody"><div class="wrap"><h2>Welcome to [GWA] Autoresponder</h2>';
echo '<table border=0><tr><td width="50%" valign="top">';
echo '<p>Welcome to the All-In-One Auto-Responder Solution for your weblog!<br />
See instructions for use on the \'<a href="?page=ar_gwa_help">Help Page</a>\'<br />
<h3>Autoresponder Settings</h3>
<form action="#" method="POST">
Send email From: <input type="text" size=29 name="arFrom" value="'.stripslashes(get_option('ar_gwa_from')).'"><br />
Email throttle (1-9): <input type="text" size=2 name="arThrottle" value="'.stripslashes(get_option('ar_gwa_throttle')).'"> <small>(Pause in seconds between msgs.)</small><br />
<input type="submit" name="submit" value="Update Settings" class="button">
&nbsp;<input type="submit" name="sched" value="Reschedule" class="button"> <small>(RESET MAILING TIME to now + 24 hours.)</small>
<input type="hidden" name="act" value="main">
</p>';
if( round(((((wp_next_scheduled('my_daily_event')-time())/60)/60)),1) < 1)
  $ar_color="red";
else
  $ar_color="green";
echo '<p><strong><span style="color:'.$ar_color.';">Next Mailing in: '.round(((((wp_next_scheduled('my_daily_event')-time())/60)/60)),1) . ' hours.<br />'; 
echo '</span><br /><small>Send Time: '.date('l jS \of F Y h:i:s A',wp_next_scheduled('my_daily_event')).'</strong><br />Current Time: '.date('l jS \of F Y h:i:s A',time()).'</small></p>';
echo 'Enter success response.<br /><textarea cols=40 name="add_lead">'.stripslashes(stripslashes(get_option('ar_gwa_addlead'))).'</textarea><br /><br />Enter unsubscribe response.<br /><textarea cols=40 name="rmv_lead">'.stripslashes(stripslashes(get_option('ar_gwa_rmvlead'))).'</textarea><br /><br />Enter subscription failure text.<br /><textarea name="bad_lead" cols=40>'.stripslashes(stripslashes(get_option('ar_gwa_badlead'))).'</textarea><br /><input type="submit" name="update" value="UDPATE"></form>';
echo '</td><td align="left" valign="top">

<br />
<img style="margin-right:20px;" align="left" src="'.get_bloginfo('url').'/wp-content/plugins/'.$ar_dir.'/plugin_ar.gif" border=0 alt="Wordpress plugins."><p align="left">Monetize your weblog with more plugins from <a href="http://Code4Cookies.com" title="Money making plugins.">Code4Cookies.com</a>.<br /><br />Start earning a residual income every day from the web-traffic on your blog.<br /><br /><a href="http://www.freeautoresponder.biz" target="_blank">Free hosting with the latest version of Wordpress</a> pre-installed with the autoresponder and more dynamic affiliate plugins for Google Adsense, Amazon, and Commission Junction.</p> 

<!-- [GWA] AutoResponder Begin -->
<form action="'.get_bloginfo('url').'/wp-content/plugins/'.$ar_dir.'/ar_gwa.php" method="POST" name="ARGWA">
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse; padding: 10px;" bordercolor="#111111">
  <tr>
    <td>
<div style="position:relative;float:left;font-family:Tahoma,Verdana,Arial,Sans; font-size:9pt; color:#000;text-align:left;width:300px;">
Place the html &lt;form&gt; code below on any webpage or simply place the WIDGET in your sidebar.
</div>
</td>
  </tr>
</table>
<input type="hidden" name="act" value="s_add">
</form>
<!-- [GWA] AutoResponder End -->
<form>
</br></br><textarea cols=50 rows=10 name="text"><!-- [GWA] AutoResponder Begin -->
<form action="'.get_bloginfo('url').'/wp-content/plugins/'.$ar_dir.'/ar_gwa.php" method="POST" name="ARGWA">
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse; padding: 10px;" bordercolor="#111111">
  <tr>
    <td>
<div style="font-family:Tahoma,Verdana,Arial,Sans; font-size:9pt; color:#000;">
<b>Send for more info:</b><br />
<b>Name:</b> <input type="text" name="name" value="" size="20"><br />
<b>Email:</b> <input type="text" name="email" value="" size="20">
<input type="submit" value="ADD" name="Add"><br>
<br>
<i><font size="1"><a href="http://freeautoresponder.biz" style="text-decoration:none;color:blue;">Get an AutoResponder 
for your Wordpress Blog.</a></font></i><br />
</div>

</td>
  </tr>
</table>
<input type="hidden" name="act" value="s_add">
</form>
<!-- [GWA] AutoResponder End -->

</textarea>
</form>
<hr align="left" width="300px"><p align="right">Created by <a href="http://www.code4cookies.com" target="_blank">Code4Cookies.com</a><br>No warranty implied or offered.<BR>Use at your own risk.</p><p align="right"><strong>BE KIND - DON\'T SPAM</strong></p></td></tr></table>
</div></div>'; 
}
 
function admin_ar_gwa_messages() {
global $wpdb;
$wpdb->show_errors();

$arSql = "SELECT * FROM " . $wpdb->prefix . "ar_gwa_msg ORDER BY mDay";
$res = $wpdb->get_results($arSql);

if($res) 
{
?>
<div id="wpbody">
<div class="wrap">
<h2>Manage Messages</h2>
<!--
<ul class="subsubsub">
<li><a href='edit.php'  class="current">All Posts</a> |</li><li><a href='edit.php?post_status=publish' >Published (1)</a></li></ul>


<p id="post-search">
	<input type="text" id="post-search-input" name="s" value="" />

	<input type="submit" value="Search Posts" class="button" />
</p>

<div class="tablenav">


<div class="alignleft">
<input type="submit" value="Delete" name="deleteit" class="button-secondary delete" />
<input type="hidden" id="_wpnonce" name="_wpnonce" value="b664c5d3d4" /><input type="hidden" name="_wp_http_referer" value="/1WP/wp-admin/edit.php" /><select name='m'>
<option selected="selected" value='0'>Show all dates</option>
<option value='200806'>June 2008</option>
</select>

<select name='cat' id='cat' class='postform' >

	<option value='0'>View all categories</option>
	<option value="1">Uncategorized</option>
</select>
<input type="submit" id="post-query-submit" value="Filter" class="button-secondary" />

</div>

<br class="clear" />
</div>
-->
<br class="clear" />
<?php
	echo '<form method="post" action="?page=ar_gwa_edit_message" id="armsgs-filter">';
	echo '<table>';
?>
<table class="widefat">

	<thead>
	<tr>

	<th scope="col" class="check-column" align="left"><input type="checkbox" onclick="checkAll(document.getElementById('armsgs-filter'));" /></th>
	<th scope="col">Day</th>
	<th scope="col">Subject</th>
	<th scope="col">Type</th>
	</tr>
	</thead>
	<tbody>
	<tr id='leads-1' class='alternate author-self status-publish' valign="top">
<?php	
	foreach($res as $row)
	{
		echo '<tr><td><input type="checkbox" name="mID[]" value="'.$row->mID.'"></td><td align="left">';
		echo $row->mDay,'</td><td>';
		echo '<a href="?page=ar_gwa_edit_message&mDay='.$row->mDay.'&mID='.$row->mID.'" title="Click to edit message">'.$row->mSubject,'</a></td><td>';
		echo '<strong>'.$row->mType,'</strong></td></tr>';
	}
	echo '</table><p>&nbsp;</p>';
	echo '<p><input type="submit" class="button" value="Delete Checked">';
	echo '<input type="hidden" name="act" value="del"></p>';
	echo '</form>';
?>
<div id="ajax-response"></div>
<div class="tablenav">
<br class="clear" />
</div>
<br class="clear" />
</div>
</div><!-- wpbody -->
</div><!-- wpcontent -->
</div><!-- wpwrap -->
<?php
  } else {
  echo '<div id="wpbody"><div class="wrap"><h2>Manage Messages</h2>No Records</div></div>';
  }
 }
 
function admin_ar_gwa_add_message() {
global $wpdb;
$wpdb->show_errors();

$g_error = array();
if(!$_REQUEST['mBody'])
$_REQUEST['mBody']='';
if(!$_REQUEST['mType'])
$_REQUEST['mType']='';
if(!$_REQUEST['act'])
$_REQUEST['act']='';

if($_REQUEST['act'] == 'add')
{
	if(!$_REQUEST['mSubject'] || !$_REQUEST['mBody']) { $g_error[''] = 20; }
	if($_REQUEST['mDay'] < 0 || $_REQUEST['mDay'] > 59 || !is_numeric($_REQUEST['mDay'])) { $g_error[] = 22; }
	else
	{
		$qry = "SELECT * FROM ".$wpdb->prefix."ar_gwa_msg WHERE mDay = '".$_REQUEST['mDay']."'";
		$res = $wpdb->get_results($qry);		
		if($res) { $g_error[] = 21; }
	}
	if(!count($g_error))
	{		
		$qry = "INSERT INTO ".$wpdb->prefix."ar_gwa_msg(mSubject, mBody, mDay, mType) VALUES('".$_REQUEST['mSubject']."','".$_REQUEST['mBody']."','".$_REQUEST['mDay']."','".$_REQUEST['mType']."')";
    $wpdb->query($qry);
		admin_ar_gwa_messages();
		exit;
	} else {
	showError($g_error);
	}
} 
?>
<script type="text/javascript" src="../wp-includes/js/tinymce/tiny_mce.js"></script>
<script type="text/javascript">
<!--
tinyMCE.init({
relative_urls: false,
theme : "advanced",
mode : "textareas",
elements : "editorContent",
width : "465",
height : "200",
	elements : 'abshosturls',
	plugins : 'advlink,advimage',
	remove_script_host : false
});
-->
</script>

<script type="text/javascript">
<!--
function toggleEditor(id) {
	if (!tinyMCE.getInstanceById(id))
		tinyMCE.execCommand('mceAddControl', false, id);
	else
		tinyMCE.execCommand('mceRemoveControl', false, id);
}
-->
</script>
<div id="wpbody">
<div class="wrap">

<form name="mForm" method="post" action="?page=ar_gwa_add_message">
<h2>Add Message</h2>
<table align="center">
	<tr>
		<td>DAY</td>
		<td><input type="text" name="mDay" style="width:100px;" maxlength="2" value=""></td>

	</tr>
	<tr>

		
		<td>TYPE</td>
		<td>
		<select name="mType" style="width:100px;" onchange="toggleEditor('editorContent')"/>
		<option value="text" >PLAIN TEXT
		<option value="html" selected>HTML
		</select>
		</td>

	</tr>
	<tr>
		<td>SUBJECT</td>
		<td><input type="text" name="mSubject" style="width:270px;" maxlength="250" value=""></td>
	</tr>
	<tr>
		<td valign="top">BODY</td>
		<td><textarea id="editorContent" name="mBody" cols="45" rows="7" style="width:370px; height:200px;"></textarea></td>

	</tr>
	<tr>
		<td>&nbsp;</td>
		<td><input type="submit" class="button" value="Add Message"></td>
	</tr>
</table>
<input type="hidden" name="act" value="add">
</form>
</div>
</div>
<?php
}

function admin_ar_gwa_edit_message() {
global $wpdb;

if($_REQUEST['act'] == 'del')
{
	// delete messages
	$mID = $_REQUEST['mID'];
	for($i = 0; $i < count($mID); $i++)
	{
		$wpdb->query("DELETE FROM " . $wpdb->prefix . "ar_gwa_msg WHERE mID='$mID[$i]'");
	}	
} else if($_REQUEST['act'] == 'edit')
{
	if(!$_REQUEST['mSubject'] || !$_REQUEST['mBody']) { $g_error[] = 20; }
	if($_REQUEST['mDay'] < 0 || $_REQUEST['mDay'] > 59 || !is_numeric($_REQUEST['mDay'])) { $g_error[] = 22; }
	else
	{
		$qry = "SELECT * FROM ".$wpdb->prefix."ar_gwa_msg WHERE mDay = '{$_REQUEST['mDay']}' AND mID != '{$_REQUEST['mID']}'";
    $res = $wpdb->get_results($qry,ARRAY_A);
		if($res) { $g_error[] = 21; }
	}
	if(!count($g_error))
	{		
		$qry="UPDATE ".$wpdb->prefix."ar_gwa_msg SET mSubject='{$_REQUEST['mSubject']}',mBody='{$_REQUEST['mBody']}',mDay='{$_REQUEST['mDay']}',mType='{$_REQUEST['mType']}' WHERE mID={$_REQUEST['mID']}";
   $res = $wpdb->query($qry);
  admin_ar_gwa_messages();
  exit;
	}
} else if($_REQUEST['mID']) { 
  $qry = "SELECT * FROM ".$wpdb->prefix."ar_gwa_msg WHERE mID='{$_REQUEST['mID']}'";
  $row = $wpdb->get_results($qry,ARRAY_A);
 if($row = $row[0])
 {
	$opt = array('text' => '', 'html' => '');
	$opt[$row['mType']] = 'selected';
	
	echo '<div id="wpbody"><div class="wrap"><form name="mForm" method="post" action="?page=ar_gwa_edit_message">';
	echo '<table align="center">';
if($row['mType']=='html') {
	echo '<script type="text/javascript" src="../wp-includes/js/tinymce/tiny_mce.js"></script>
<script type="text/javascript">
<!--
tinyMCE.init({
relative_urls: false,
theme : "advanced",
mode : "textareas",
elements : "editorContent",
width : "465",
height : "200",
	elements : \'abshosturls\',
	plugins : \'advlink,advimage\',
	remove_script_host : false
});
-->
</script>

<script type="text/javascript">
<!--
function toggleEditor(id) {
	if (!tinyMCE.getInstanceById(id))
		tinyMCE.execCommand(\'mceAddControl\', false, id);
	else
		tinyMCE.execCommand(\'mceRemoveControl\', false, id);
}
-->
</script>'."\n\n";
}



	echo '<tr><td>DAY</td>';
	echo '<td><input type="text" name="mDay" style="width:100px;" value="'.$row['mDay'].'"></td></tr>';
	
	echo '<tr><td>TYPE</td>';
	echo '<td><select name="mType" style="width:100px;" onchange="toggleEditor(\'contentEditor\')">';
	echo '<option value="text" '.$opt['text'].'>PLAIN TEXT</option>';
	echo '<option value="html" '.$opt['html'].'>HTML</option>';
	echo '</select></td></tr>';
	
	echo '<tr><td>SUBJECT</td>';
	echo '<td><input type="text" name="mSubject" style="width:270px;" maxlength="250" value="'.$row[mSubject].'"></td></tr>';
	
	echo '<tr><td valign="top">BODY</td>';
	echo '<td><textarea id="contentEditor" name="mBody" style="width:270px; height:200px;">'.$row['mBody'].'</textarea></td></tr>';
	
	echo '<tr><td>&nbsp;</td>';
	echo '<td><input type="submit" class="button" value="Edit Message"></td></tr>';
	
	echo '</table>';
	echo '<input type="hidden" name="act" value="edit">';
	echo '<input type="hidden" name="mID" value="'.$_REQUEST['mID'].'">';

	echo '</form></div></div>';
 }
 else { 
  echo getError(100);
 }
} else {
admin_ar_gwa_messages();
}
}
function admin_ar_gwa_leads() { 
global $wpdb;
$wpdb->show_errors();
$orderby = strip_tags($_REQUEST['orderby']);
if(!isset($orderby) || $orderby=='') $orderby = 'lName';
if($_REQUEST['dir']) {
  $dir = 0;
  $orderby .= ' asc';
  } else {
  $dir=1;
  $orderby .= ' desc';  
  }
if($_REQUEST['act'] == 'del')
{
	// delete messages
	$lID = $_REQUEST['lID'];
	for($i = 0; $i < count($lID); $i++)
	{
		$wpdb->query("DELETE FROM " . $wpdb->prefix . "ar_gwa_leads WHERE lID='$lID[$i]'");
	}	
}
$arSql = "SELECT * FROM " . $wpdb->prefix . "ar_gwa_leads ORDER BY ".$orderby;
$res = $wpdb->get_results($arSql);
if($res) {
?>
<div id="wpbody">
<div class="wrap">
<form action="?page=ar_gwa_leads" method="post" id="leads-filter">
<h2>Manage Leads (<?php echo count($res); ?>)</h2>
<table class="widefat">
	<thead>
	<tr>
	<th scope="col" class="check-column"><input type="checkbox" onclick="checkAll(document.getElementById('leads-filter'));" /></th>
	<th scope="col"><a href="?page=ar_gwa_leads&orderby=lName&dir=<?=$dir;?>">Name</a></th>
	<th scope="col"><a href="?page=ar_gwa_leads&orderby=lEmail&dir=<?=$dir;?>">Email</a></th>
	<th scope="col"><a href="?page=ar_gwa_leads&orderby=lMOut&dir=<?=$dir;?>">Msg Out</th>
	<th scope="col"><a href="?page=ar_gwa_leads&orderby=lDateEntry&dir=<?=$dir;?>">Entry Date</th>
	<th scope="col"><a href="?page=ar_gwa_leads&orderby=lDateOut&dir=<?=$dir;?>">Date Out</th>
	</tr>
	</thead>
	<tbody>
	<tr id='post-1' class='alternate author-self status-publish' valign="top">
<?php
	foreach($res as $row)
	{	

		echo '<tr><th scope="row" class="check-column"><input type="checkbox" name="lID[]" value="'.$row->lID.'" /></th>'
				.'<td><abbr title="'.$row->lEmail.'">'.$row->lName.'</abbr></td>'
				.'<td><strong><a class="row-title" href="mailto:'.$row->lEmail.'" title="Email Lead">'.$row->lEmail.'</a></strong></td>'
				.'<td>'.$row->lMOut.'</td>'
				.'<td>'.$row->lDateEntry.'</td>'
				.'<td>'.$row->lDateOut.'</td></tr>';
  }
  ?>
	</tbody>
<?php
	echo '</table><p>&nbsp;</p>';
	echo '<p><input type="submit" class="button" value="Delete Checked">';
	echo '<input type="hidden" name="act" value="del"></p>';
	echo '</form>';
?>
<div id="ajax-response"></div>
<div class="tablenav">
<br class="clear" />
</div>
<br class="clear" />
</div>
</div><!-- wpbody -->
</div><!-- wpcontent -->
</div><!-- wpwrap -->
<?php
  } else {
  echo '<div id="wpbody"><div class="wrap"><h2>Manage Leads</h2>No Records</div></div>';
  }
}

function admin_ar_gwa_add_leads() {
global $wpdb;
$wpdb->show_errors();

// check if there's email and name
if(($_REQUEST['lEmail']=="" && $_REQUEST['lName']=="" && ($_REQUEST['addresses']!='' && preg_match("/\n/",$_REQUEST['addresses'])) && $_REQUEST['act']=="add")) { 
 if(!preg_match("/,/",$_REQUEST['addresses'])) { 
 $g_error[] = 23; showError($g_error);
 } else {
  $lines = preg_split("/\n/",$_REQUEST['addresses']);
  $dups=0;
  foreach($lines as $ttline) {
  $tttline = preg_split("/,/",$ttline);
  $tttline[1] = preg_replace("/\s+$/",'',$tttline[1]);
  $tttline[1] = preg_replace("/\n+$/",'',$tttline[1]);
    if(!$wpdb->query("SELECT lEmail FROM ".$wpdb->prefix."ar_gwa_leads WHERE lEmail='".$tttline[1]."'"))
      $lines2[] = $ttline;  
    else
      $dups++; 
  }
if(count($lines2)>0) {
  foreach($lines2 as $tline) {
   $qry = "INSERT INTO ".$wpdb->prefix."ar_gwa_leads (lName,lEmail,lDateEntry,lDateOut,lMOut) VALUES ";
   $line = preg_split("/,/",$tline);
   if($line[0]!='' && $line[1]!='')
    $qry .= "('".mysql_real_escape_string($line[0])."','".mysql_real_escape_string($line[1])."',current_date, current_date, '-1')";
#    $qry = substr($qry, 0, -2);
    $wpdb->query($qry);
		$ms = new MailProcess();
		if( $ms->setLead($wpdb->insert_id) && $ms->setMsg(0))
		{
		 if(isset($_POST['sendwelcome'])) {
		  $ms->mailLead(0,$wpdb->insert_id);
     } else {
      $subq = "lMOut='0', ";
	  	$qry = "UPDATE ".$wpdb->prefix."ar_gwa_leads SET $subq lDateOut=current_date WHERE lID='".$wpdb->insert_id."'";
      $wpdb->query($qry);     
     }
    }    
   } 
  }
 }
 $success = count($lines2);
}

else if ($_REQUEST['lEmail'] && $_REQUEST['lName'])
{
	// check if email is already in use
	$qry = "SELECT * FROM ".$wpdb->prefix."ar_gwa_leads WHERE lEmail='".$_REQUEST['lEmail']."'";
	if($wpdb->get_results($qry)) { $g_error[] = 10; }

	if(!count($g_error))
	{	
		// insert lead
		$qry = "INSERT INTO ".$wpdb->prefix."ar_gwa_leads(lName, lEmail, lDateEntry, lDateOut, lMOut) VALUES('".mysql_real_escape_string($_REQUEST['lName'])."', '".mysql_real_escape_string($_REQUEST['lEmail'])."' ,current_date, current_date, '-1')";
		$wpdb->query($qry);
		$ms = new MailProcess();
		if( $ms->setLead($wpdb->insert_id) && $ms->setMsg(0))
		{
		$ms->mailLead(0,$wpdb->insert_id);
    admin_ar_gwa_leads();
    exit;
    }
		echo 'skipped'.$wpdb->insert_id;exit;	
	} else {
    showError($g_error);
    admin_ar_gwa_leads();
  } 
} else if($_REQUEST['act']=="add"){
 $g_error[] = 12; 
 showError($g_error);
}
?>
<div id="wpbody">
<div class="wrap">
<form method="post" action="?page=ar_gwa_add_leads">
<h2>Add Lead</h2>
<input type="hidden" name="act" value="add">
<?php
if($success>0) echo '<div id="message" class="updated fade">
  <p>Successfully added '.$success.' addresses.</p>
  </div>';
if($dups>0) echo '<div id="message" class="error fade">
  <p>There were '.$dups.' duplicates that were already on the list.</p>
  </div>';
?>
<table align="center">
	<tr>
		<td>NAME: <input type="text" name="lName" maxlength="250" style="width:270px;"></td>

	</tr>
	<tr>
		<td>EMAIL: <input type="text" name="lEmail" maxlength="250" style="width:270px;"></td>
	</tr>
	<tr>
		<td><input type="submit" class="button" value="Add New Lead"></td>

	</tr>
  <tr>
  <td>
<p><input type="checkbox" name="sendwelcome" value="on"> Send first email as if members just subscribed.</p>
<p>COPY&PASTE your email address list in the '.csv' format. <br />Each line must end with a single carriage return.<br />Separate a name followed by their email with a comma. <br />
Enter only one name & address per line. <br />
DUPLICATES WILL BE PRUNED FROM YOUR LIST.
</p>
<textarea name="addresses" cols=80 rows=25></textarea><br />
<input type="submit" class="button" value="Add New Lead">
</td></tr></table>
</form>
			</div>
			</div>

<?php
 }
 
function admin_ar_gwa_email_leads() {
if($_REQUEST['act']!=filter) {
?>
<script type="text/javascript" src="../wp-includes/js/tinymce/tiny_mce.js"></script>
<script type="text/javascript">
<!--
tinyMCE.init({
relative_urls: false,
theme : "advanced",
mode : "textareas",
elements : "editorContent",
width : "465",
height : "200",
	elements : 'abshosturls',
	plugins : 'advlink,advimage',
	remove_script_host : false
});
-->
</script>

<script type="text/javascript">
<!--
function toggleEditor(id) {
	if (!tinyMCE.getInstanceById(id))
		tinyMCE.execCommand('mceAddControl', false, id);
	else
		tinyMCE.execCommand('mceRemoveControl', false, id);
}
-->
</script>
<div id="wpbody">
<div class="wrap">
			<h2>Email Leads</h2>
<form name="form1" method="post" action="?page=ar_gwa_email_leads" onSubmit="return validate();">
<h3>FILTER LEADS</h3>
<table align="center">
	<tr>

		<td width="90">Added after</td>
		<td width="90"><input type="text" name="fADate" style="width:80px;" maxlength="10"></td>
		<td>yyyy-mm-dd</td>
	</tr>
	<tr>
		<td>Added before</td>
		<td><input type="text" name="fBDate" style="width:80px;" maxlength="10"></td>

		<td>yyyy-mm-dd</td>
	</tr>
</table>

<p>&nbsp;</p>

<h3>MESSAGE</h3>
<table align="center">
	<tr>
		<td>TYPE</td>

		<td>
		<select name="mType" style="width:100px;" onchange="toggleEditor('editorContent')" />
		<option value="html" selected>HTML
		<option value="text">PLAIN TEXT
		</select>
		</td>
	</tr>
	<tr>
		<td>SUBJECT</td>

		<td><input type="text" name="mSubject" style="width:250px;" maxlength="250"></td>
	</tr>
	<tr>
		<td valign="top">BODY</td>
		<td><textarea id="editorContent" name="mBody" style="width:250px; height:200px;"></textarea></td>
	</tr>
	<tr>
		<td>&nbsp;</td>

		<td><input type="submit" class="button" value="Continue >>"></td>
	</tr>
</table>

<p>&nbsp;</p>

<table align="center">
	<tr>
		<th>TAGS</th>
		<th>DESCRIPTION</th>

	</tr>
	<tr>
		<td>&lt;?Name?&gt;</td>
		<td>Name of the lead</td>
	</tr>
	<tr>
		<td>&lt;?Email?&gt;</td>

		<td>Email of the lead</td>
	</tr>
	<tr>
		<td>&lt;?Unsubscribe?&gt;</td>
		<td>Link for the lead to unsubscribe</td>
	</tr>
</table>
<input type="hidden" name="act" value="filter">

</form>

			</div>
			</div>
<?php
 } else {
// EMAIL LEADS
global $wpdb;
$wpdb->show_errors();
	$after  = $_REQUEST['fADate'];
	$before = $_REQUEST['fBDate'];
	if(!$after)
	{
		$qry = "SELECT lDateEntry FROM ".$wpdb->prefix."ar_gwa_leads ORDER BY lDateEntry LIMIT 0,1";
  	$after = $wpdb->get_var($qry);
	}
	
	if(!$before) 
	{
		$before = $wpdb->get_var("SELECT current_date");
	}
	
	echo '<div id="wpbody">
<div class="wrap">
			<h2>Email Leads</h2>';
	
	$qry = "SELECT * FROM ".$wpdb->prefix."ar_gwa_leads WHERE lDateEntry >= '$after' AND lDateEntry <= '$before'";
	$res = $wpdb->get_results($qry,ARRAY_A);
	if($res)
	{
	$stime = time();
		// vars
		$ms 		= new MailProcess(); 
		$sleep  = get_option('ar_gwa_throttle');
    $lEmailed 	= 0; 
		$aMsg		= array('mType' => $_REQUEST['mType'], 'mSubject' => $_REQUEST['mSubject'], 'mBody' => $_REQUEST['mBody']);
	
		foreach($res as $row) 
		{
			if($ms->setLead($row['lID']) && $ms->setMsg2($aMsg))
			{
				$ms->mailLead();
				++$lEmailed;
			sleep($sleep);
      }			
		}
	$etime = time();
		echo '<p>Sent '. $lEmailed, ' emails.</p>';
	echo "<p>The process ran for ".($etime - $stime)." seconds and paused for $sleep seconds between each mailing.</p>";
  echo "<p>Depending upon your server configuration the script will have a<br />maximum run time which may be exceeded while processing your mailing list. You can lower the throttle to speed up the mailing but at some point you may find your website host complain of your spamming. </p>
  <p>If your script is timing out and not all your emails are being sent you can<br /> get a free Wordpress Weblog from <a href='http://www.freeautoresponder.biz'>FreeAutoresponder.biz</a> to process more emails.</p>";
  }
	else { echo getError(14); }
 }
echo '</div></div>';
}

function admin_ar_gwa_export_leads() {
ar_gwa_export();
}
 
function ar_gwa_export() {
global $wpdb;
$buffer = '';
$qry = "SELECT * FROM ".$wpdb->prefix."ar_gwa_leads ORDER BY lName";
$res = $wpdb->get_results($qry,ARRAY_A);
if(count($res)) {
 foreach($res as $row)
 {
		$buffer .= $row[lName].','.$row[lEmail]."\n";
 }
}
echo '<div id="wpbody"><div class="wrap"><h2>EXPORT LEADS ('.count($res).')</h2>';
echo '<div style="width:50%;"><p><form action="#" name="Exp" id="fExp" style="margin-top:20px;"><textarea cols=50 rows=20 name="arExp" id="ariExp">'.$buffer.'</textarea></form></div><div style="width:45%;margin-top:7px;"><p style="padding-left:50px;padding-right:20px;">COPY&PASTE the contents of the textbox into your favorite<br />ASCII editor (or spreadsheet) and save (or export) as a ".csv" file.</p></div></div></div>';
}
 
function admin_ar_gwa_run() {
echo '<div id="wpbody"><div class="wrap"><h2>RUN</h2>
<p>Manually running the Autoresponder.</p>';
do_this_daily();
}

function admin_ar_gwa_help() {
global $ar_dir;
?>
<div id="wpbody">
<div class="wrap">
<h2>Help</h2>
<h3>Personalize your messages.</h3>
<p>The following tags can be added to your email messages:<br>
<b>&lt;?Name?> : Subscriber's name.<br>
&lt;?Email?> : Subscriber's email address.</b> <b><br>
&lt;?Unsubscribe?> : Add an UNSUBSCRIBE LINK in your mailing.</b></p>

<h3>Setup Messages</h3>
<p>You add new messages to the autoresponder on the <a href="?page=ar_gwa_add_message">Add Message</a> tab. You must set the day that the message will be sent by entering the number of days after joining that the subscriber should recieve the email. Enter 0 (zero) to have the message  sent immediately when the lead is added. <br /><strong>NOTE</strong> that only 1 (one) email message may be scheduled for delivery each day. </p>

<h3>Running your Autoresponder</h3>
<p>[GWA] Autoresponder Plug-in is completely automated. The appropriate messages are 
automatically sent to all subscribed addresses scheduled for delivery each day.<br />You can still manually start the mailings by clicking the '<a href="?page=ar_gwa_run">RUN</a>' tab in the 
menu.<br /><br /><strong>IMPORTANT NOTE</strong>: The Wordpress simulated CRON feature will run the first time your blog is visited after the scheduled mailing time has passed. You can <strong>Reschedule</strong> the time your messages are sent each day to the current time on the '<a href="?page=<?=$ar_dir?>/ar_gwa.php">Autoresponder</a>' tab. If you do not get regular traffic to your weblog you will want to setup a proper CRON JOB in your host's Server Control Panel to load your weblog homepage a minute or so after the time you set for your mailing in the settings for this plugin. This will ensure your autoresponder keeps to schedule.</p>

<h3>Still having trouble?</h3>
<p>Get a free Wordpress Hosting Account at <a href="http://www.FreeAutoresponder.biz" target="_blank">FreeAutoresponder.biz</a>.<br />One Click Installation of Wordpress (v2.6) and the latest version of the plugin.<br />Our server provides the best service for your Autoresponder and Wordpress.</p>  
<p>Or you can try to contact me by email at
<a href="mailto:cookies@getwebactive.com">cookies@getwebactive.com</a></p>

			</div>
			</div>
<?php
}

function admin_ar_gwa_about() {
echo '<div id="wpbody"><div class="wrap"><h2>About [GWA] Autoresponder</h2><p>Created by <a href="http://www.code4cookies.com" target="_blank">Code4Cookies.com</a><br>No warranty implied or offered.<BR>Use at your own risk.</p><p><strong>BE KIND - DON\'T SPAM</strong></p></div></div>';
}

function modify_ar_gwa_menu() {

add_menu_page('AutoResponder','[GWA] Autoresponder', 7, __FILE__, 'admin_ar_gwa_main');
add_submenu_page(__FILE__, 'Autoresponder', 'Autoresponder', 7, __FILE__, 'admin_ar_gwa_main');
add_submenu_page(__FILE__, 'Add Message', 'Add Message', 7, 'ar_gwa_add_message','admin_ar_gwa_add_message');
add_submenu_page(__FILE__, 'Edit Messages', 'Edit Message', 7, 'ar_gwa_edit_message', 'admin_ar_gwa_edit_message');
add_submenu_page(__FILE__, 'Leads', 'Leads', 7, 'ar_gwa_leads', 'admin_ar_gwa_leads');
add_submenu_page(__FILE__, 'Add Leads', 'Add Leads', 7, 'ar_gwa_add_leads', 'admin_ar_gwa_add_leads');
add_submenu_page(__FILE__, 'Export Leads', 'Export Leads', 7, 'ar_gwa_export_leads', 'admin_ar_gwa_export_leads');
add_submenu_page(__FILE__, 'Email Leads', 'Email Leads', 7, 'ar_gwa_email_leads', 'admin_ar_gwa_email_leads');
add_submenu_page(__FILE__, 'Run', 'RUN', 7, 'ar_gwa_run', 'admin_ar_gwa_run');
add_submenu_page(__FILE__, 'Help', 'Help', 7, 'ar_gwa_help', 'admin_ar_gwa_help');
add_submenu_page(__FILE__, 'About', 'About', 7, 'ar_gwa_about', 'admin_ar_gwa_about');
}

function set_ar_gwa_options()
{
global $wpdb;
if($_REQUEST['arFrom']!="")
$sendEmail = $_REQUEST['arFrom'];
else
$sendEmail = get_option('ar_gwa_from');

if($_REQUEST['arThrottle'] != "" && preg_match("/^\d$/",$_REQUEST['arThrottle']) )
$throttle = $_REQUEST['arThrottle'];
else
$throttle = get_option('ar_gwa_throttle');

delete_option('ar_gwa_from');
delete_option('ar_gwa_throttle');
delete_option('ar_gwa_addlead');
delete_option('ar_gwa_badlead');
delete_option('ar_gwa_rmvlead');

add_option('ar_gwa_from',$sendEmail,'');
add_option('ar_gwa_throttle',$throttle,'');
add_option('ar_gwa_addlead',$wpdb->escape($_REQUEST['add_lead']),'');
add_option('ar_gwa_badlead',$wpdb->escape($_REQUEST['bad_lead']),'');
add_option('ar_gwa_rmvlead',$wpdb->escape($_REQUEST['rmv_lead']),'');
}

function unset_ar_gwa_options()
{
delete_option('ar_gwa_from');
delete_option('ar_gwa_throttle');
delete_option('ar_gwa_addlead');
delete_option('ar_gwa_badlead');
delete_option('ar_gwa_rmvlead');

wp_clear_scheduled_hook('my_daily_event');
}

function autoresponder_gwa_form_display() {
$burl = get_bloginfo('url');
global $ar_dir;
?>
<!-- [GWA] AutoResponder Begin -->
<form action="<?=$burl;?>/wp-content/plugins/<?=$ar_dir;?>/ar_gwa.php" method="POST" name="ARGWA">
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse; padding: 10px;" bordercolor="#111111">
  <tr>
    <td>
<div style="font-family:'Trebuchet MS',Tahoma,Verdana,Arial; font-size:11pt; color:#000;">
<em>Send for more info:</em><br />
Name: <input type="text" name="name" value="" size="20"><br />
Email: <input type="text" name="email" value="" size="20">
<p align="center" style="margin-top:0px;"><input type="submit" value="SUBMIT" name="Add">
</div>
</td>
  </tr>
</table>
<input type='hidden' name='act' value='s_add'>
</form>
<!-- [GWA] AutoResponder End -->
<?php
}

$ar_gwa_db_version = "1.0";

function do_this_daily($n=NULL) {
global $wpdb;

$ar_cnt = 0;
$ms = new MailProcess(); 
$qry = "SELECT TO_DAYS(current_date) as AA, TO_DAYS(lDateEntry) as BB, lID, lMOut FROM ".$wpdb->prefix."ar_gwa_leads ORDER BY lID";
$res = $wpdb->get_results($qry,ARRAY_A);
if(count($res)) {
 foreach($res as $row)
 {
	$dif = $row['AA'] - $row['BB'];
	if($dif > 0 && $dif < 61)
	{
		$mDay = $row['lMOut'] + 1;
		while($mDay <= $dif)
		{
			if($ms->setLead($row['lID']) && $ms->setMsg($mDay))
			{
				$ms->mailLead();
				$ar_cnt++;
				echo '.';
			}
			$mDay++;
		}
	}
 } 
 if (!wp_next_scheduled('my_daily_event')) {
 wp_clear_scheduled_hook('my_daily_event');
 wp_schedule_event( time()+86400, 'daily', 'my_daily_event' );
 }
}
if($ar_cnt>0 && ! $n)
echo '<p><strong>Success. Sent '.$ar_cnt.' email.</strong></p></div></div>';
else if (!$n)
echo '<p><strong><em>No email to send?</em></strong></p><p>To compose a new one-time message and send it to some or all of your autoresponder list right now use the form on the <a href="?page=ar_gwa_email_leads">Email Leads</a> tab.</div></div>';
}


function getError($n) 
{	
	switch($n)
	{
	case 1:
		return '<p class="error"><b>ERROR:</b> Invalid login/password.</p>';
	case 2:
		return '<p class="error"><b>ERROR:</b> A problem occured with your MySQL connection.</p>';
	case 3:
		return '<p class="error"><b>ERROR:</b> Access Denied. You must login to access the file you requested.</p>';
	case 10:
		return '<p class="error"><b>ERROR:</b> Email already in use.</p>';	
	case 11:
		return '<p class="error"><b>ERROR:</b> Name/Email are mandatory.</p>';
	case 12:
		return '<p class="error"><b>ERROR:</b> Invalid Email/Name.</p>';
	case 13:
		return '<p class="error"><b>ERROR:</b> Email not found.</p>';
	case 14:
		return '<p class="error">No leads found. Please, try again.</p>';
	case 20:
		return '<p class="error"><b>ERROR:</b> Subject and body are mandatory.</p>';
	case 21:
		return '<p class="error"><b>ERROR:</b> Invalid day of message. There\'s another message set to this day.</p>';
	case 22:
		return '<p class="error"><b>ERROR:</b> Day must be a value between 0 and 59.</p>';
	case 23:
		return '<p class="error"><b>ERROR:</b> Bad format for Bulk Address Field.</p>';
	case 100:
		return '<p class="error"><b>ERROR:</b> Register not found.</p>';
	case 101:
		return '<p class="error">Register not found.</p>';
	
	default:
		return 'UNKNOWN ERROR.';
	}
}

function showError($error)
{
	$error = array_unique($error);
	
	echo '<div>';
	foreach($error as $v)
	{
		echo getError($v), '<br>';
	}
	echo '</div>';
}

function ar_gwa_install () {
   global $wpdb;
   $wpdb->show_errors;
   global $ar_gwa_db_version;
    add_option('ar_gwa_addlead','Subscribed to the newsletter.');
    add_option('ar_gwa_badlead','There was a problem with your email. Try Again!');
    add_option('ar_gwa_rmvlead','Your email has been unsubscribed successfully.');
    add_option('ar_gwa_from',get_bloginfo('admin_email'));
    add_option('ar_gwa_throttle','5');
    wp_schedule_event((time()+86400), 'daily', 'my_daily_event');
   $dn = 0;

   $table_name = $wpdb->prefix . "ar_gwa_leads";
   if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
   
    $sql = "CREATE TABLE `" . $table_name . "` (
  `lID` int(11) NOT NULL auto_increment,
  `lName` varchar(250) default NULL,
  `lEmail` varchar(250) default NULL,
  `lDateEntry` date default NULL,
  `lDateOut` date default NULL,
  `lMOut` varchar(11) default NULL,
   PRIMARY KEY  (`lID`)
  );";
   $results = $wpdb->query( $sql );
  }
    
   $table_name = $wpdb->prefix . "ar_gwa_msg";
   if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
    $sql = "CREATE TABLE `" . $table_name . "` (
  `mID` int(11) NOT NULL auto_increment,
  `mSubject` varchar(250) default NULL,
  `mBody` text,
  `mDay` int(2) default NULL,
  `mType` varchar(50) default NULL,
    PRIMARY KEY  (`mID`)
  )";
   $results = $wpdb->query( $sql );
   } 
   $msg_num = $wpdb->get_var("SELECT `mID` from `".$table_name."` ORDER BY mDay ASC LIMIT 1");
   if (!$msg_num) {
    $sql = "INSERT INTO `".$table_name."` (`mID`, `mSubject`, `mBody`, `mDay`, `mType`) VALUES (0,'Welcome', '".mysql_real_escape_string("Hi <?Name?><br />\r\nThis is the default welcome message!<br />The webmaster has just installed this Autoresponder Plugin for Wordpress from <a href='www.GetWebActive.com'>GetWebActive.com</a>\r\n<br />\r\n<?Unsubscribe?>")."', '0', 'html')";
    $results = $wpdb->query( $sql );
   }
}

add_action('admin_menu','modify_ar_gwa_menu');
add_action('my_daily_event', 'do_this_daily');
register_activation_hook(__FILE__, 'ar_gwa_install');
register_activation_hook(__FILE__,'set_ar_gwa_options');
register_deactivation_hook(__FILE__,'unset_ar_gwa_options');

class MailProcess
{
	var $lead   = array();
	var $msg    = array();	
	var $arFrom;

	function MailProcess()
	{
		$this->arFrom = get_option('ar_gwa_from');
	}
	
	function setLead($lID)
	{
	global $wpdb;
		// get lead info
		$qry = "SELECT * FROM ".$wpdb->prefix."ar_gwa_leads WHERE lID='$lID'";
    $res = $wpdb->get_results($qry,ARRAY_A);
		if($res) 
		{ 
			$this->lead = $res[0];
			return 1;
		}
		return 0;		
	}

	function setMsg($mDay)
	{
	global $wpdb;

	$this->msg['mDay'] = $mDay;
		$qry = "SELECT * FROM ".$wpdb->prefix."ar_gwa_msg WHERE mDay='$mDay'";

		$res = $wpdb->get_results($qry,ARRAY_A);
    if($res) 
		{ 
			$this->msg = $res[0];
			$this->msg['mHeader'] = 'From: <'.$this->arFrom.">\n";
		$this->msg['mHeader'] .= 'Reply-To: <'.$this->arFrom.">\n";
			if($this->msg['mType'] == 'html')
			{
				$this->msg['mHeader'] .= 'Content-type: text/html; charset=iso-8859-1'."\n";
			}			
			return 1;
		}
		return 0;
	}

	function setMsg2($msg)
	{
		$this->msg['mSubject'] = $msg['mSubject'];
		$this->msg['mBody'] = $msg['mBody'];
		$this->msg['mHeader'] = 'From: <'.$this->arFrom.">\n";
		$this->msg['mHeader'] .= 'Reply-To: <'.$this->arFrom.">\n";
		$this->msg['mType'] = $msg['mType'];
		if($msg['mType'] == 'html')
		{
				$this->msg['mHeader'] .= 'Content-type: text/html; charset=iso-8859-1'."\n";
		}
		return 1;
	}

	function mailLead($mDay=null,$lID=null)
	{
		global $wpdb;
    $this->msg['mBody'] .= "\nMailed by the [GWA] Wordpress Autoresponder Plugin at ".get_bloginfo("name").'.';
		if(!count($this->lead) || !count($this->msg)) { return 0; }
		$this->formatMsg();
    mail('<'.$this->lead['lEmail'].'>', $this->msg['mSubject'], $this->msg['mBody'], $this->msg['mHeader']);
    if(isset($this->msg['mDay']))
      $subq = "lMOut='".$this->msg['mDay']."', ";
		$qry = "UPDATE ".$wpdb->prefix."ar_gwa_leads SET $subq lDateOut=current_date WHERE lID='".$this->lead['lID']."'";
		$r = $wpdb->query($qry);
	}
	
	function formatMsg()
	{
	global $ar_dir;
		$unsubscribe = get_bloginfo('url').'/wp-content/plugins/'.$ar_dir.'/ar_gwa.php?lEmail='.$this->lead['lEmail'].'&uID='.$this->lead['lID'];

		if($this->msg['mType'] == 'html') { $unsubscribe = '<a href="'.$unsubscribe.'">'.unsubscribe.'</a>'; }
		$this->msg['mBody'] = str_replace('<?Name?>', $this->lead['lName'], $this->msg['mBody']);
		$this->msg['mSubject'] = str_replace('<?Name?>', $this->lead['lName'], $this->msg['mSubject']);
		$this->msg['mBody'] = str_replace('<?Email?>', $this->lead['lEmail'], $this->msg['mBody']);
		$this->msg['mSubject'] = str_replace('<?Email?>', $this->lead['lEmail'], $this->msg['mSubject']);
		$this->msg['mBody'] = str_replace('<?Unsubscribe?>', $unsubscribe, $this->msg['mBody']);
//For html emails composed in tinymce
		$this->msg['mBody'] = str_replace('&lt;?Name?&gt;', $this->lead['lName'], $this->msg['mBody']);
		$this->msg['mSubject'] = str_replace('&lt;?Name?&gt;', $this->lead['lName'], $this->msg['mSubject']);
		$this->msg['mBody'] = str_replace('&lt;?Email?&gt;', $this->lead['lEmail'], $this->msg['mBody']);
		$this->msg['mSubject'] = str_replace('&lt;?Email?&gt;', $this->lead['lEmail'], $this->msg['mSubject']);
		$this->msg['mBody'] = str_replace('&lt;?Unsubscribe?&gt;', $unsubscribe, $this->msg['mBody']);
	}
}

?>
